﻿using System.Configuration;
using System.Web.Hosting;
using System.Web.Mvc;
using SPS.Client.Frame;
using SPS.Client.Frame.NemId;

namespace SPSClientDemoMVC.Controllers
{
    public class KeyfileController : Controller
    {
        [OutputCache(NoStore = true, Duration = 0, VaryByParam = "None")]
        public ActionResult Logon()
        {
            ViewBag.Maintitle = "Keyfile logon";
            UpdateViewBagWithNemIdParameters(new KeyFileFrameBuilder());
            return View();
        }

        public ActionResult SignPdf()
        {
            ViewBag.Maintitle = "Keyfile Signature (PDF)";
            var path = ConfigurationManager.AppSettings["testPdfPath"];
            if (!System.IO.File.Exists(path))
            {
                path = HostingEnvironment.MapPath(ConfigurationManager.AppSettings["testPdfPath"]);
            }
            var frameBuilder = new KeyFileSignFrameBuilder().SignPdf(System.IO.File.ReadAllBytes(path));
            UpdateViewBagWithNemIdParameters(frameBuilder);
            return View();
        }

        public ActionResult SignText()
        {
            ViewBag.Maintitle = "Keyfile Signature (Text)";
            var messageToBeSigned = "IT-løsning fra Signaturgruppen\nLicens og assistance\n\n\nDer tilbydes kontrakt mellem parterne...";
            UpdateViewBagWithNemIdParameters(new KeyFileSignFrameBuilder().SignText(messageToBeSigned));

            return View();
        }
        
        private void UpdateViewBagWithNemIdParameters(FrameBuilder frameBuilder)
        {
            ViewBag.NemIdParameterBlock = frameBuilder.GetScript(Url.Action("HandleBackendResponse", "Home"));
            ViewBag.IframeUrl = frameBuilder.FrameUrl;
        }
    }
}