﻿using System.Configuration;
using System.Web.Hosting;
using System.Web.Mvc;
using SPS.Client.Frame;
using SPS.Client.Frame.NemId;

namespace SPSClientDemoMVC.Controllers
{
    public class NemidController : Controller
    {
        [OutputCache(NoStore = true, Duration = 0, VaryByParam = "None")]
        public ActionResult Logon()
        {
            ViewBag.Maintitle = "NemID Logon";
            UpdateViewBagWithNemIdParameters(new NemIDFrameBuilder().WithTransactionContext("Du er ved at godkende login til SPS Demo"));
            return View();
        }

        public ActionResult SignPdf()
        {
            ViewBag.Maintitle = "NemID Signature (PDF)";
            var path = ConfigurationManager.AppSettings["testPdfPath"];
            if (!System.IO.File.Exists(path))
            {
                path = HostingEnvironment.MapPath(ConfigurationManager.AppSettings["testPdfPath"]);
            }
            var frameBuilder = new NemIDSignFrameBuilder()
                .SignPdf(System.IO.File.ReadAllBytes(path));

            UpdateViewBagWithNemIdParameters(frameBuilder);

            return View();
        }

        public ActionResult SignText()
        {
            ViewBag.Maintitle = "NemID Signature (Text)";
            const string messageToBeSigned = "IT-løsning fra Signaturgruppen\nLicens og assistance\n\n\nDer tilbydes kontrakt mellem parterne...";
            UpdateViewBagWithNemIdParameters(new NemIDSignFrameBuilder().SignText(messageToBeSigned));

            return View();
        }

        private void UpdateViewBagWithNemIdParameters(FrameBuilder frameBuilder)
        {
            ViewBag.NemIdParameterBlock = frameBuilder.GetScript(Url.Action("HandleBackendResponse", "Home"));
            ViewBag.IframeUrl = frameBuilder.FrameUrl;
        }
    }
}