﻿using System.Web.Mvc;
using System.Web.Optimization;
using System.Web.Routing;
using log4net;
using SPS.Client.Logging;

namespace SPSClientDemoMVC
{
    public class MvcApplication : System.Web.HttpApplication
    {
        protected void Application_Start()
        {
            AreaRegistration.RegisterAllAreas();
            FilterConfig.RegisterGlobalFilters(GlobalFilters.Filters);
            RouteConfig.RegisterRoutes(RouteTable.Routes);
            BundleConfig.RegisterBundles(BundleTable.Bundles);

            log4net.Config.XmlConfigurator.Configure();

            //Configures the debug-logging for the SPS.Client
            //Specify any action(string) => void method you like - any debug messages from SPS.Client will be invoked on that action
            var logger = LogManager.GetLogger("Signaturgruppen.SpsClientLogger");
            SpsClientLogger.DebugAction = logger.Debug;
            SpsClientLogger.InfoAction = logger.Info;
        }
    }
}